<!DOCTYPE html>
<html lang="en">
    <head>
        <title>Polynomial Arithmetic Experiment</title>
        <meta name="viewport" content="width=device-width,height=device-height,initial-scale=1.0" />
        <meta charset="utf-8"/>
        <style>
         .exp {
             display: none;
         }
         table {
             font-family: arial, sans-serif;
             border-collapse: collapse;
             width: 100%;
             text-align: center;
         }
         th {
             background-color:#2780C6;
             text-align: center;
             color:#fff;
         }
         #headings {
             background-color:#2780C6;
             text-align: center;
             color:#fff;
         }
         td {
             border: 1px solid #dddddd;
             padding: 8px;
             text-align: center;
             height:20px;
         }
         tr:hover {
             background-color: #ddd;
         }
        </style>
         <!-- Google Tag Manager -->
         <script class="gtm">
           window.dataLayer = window.dataLayer || [];
           
           window.dataLayer.push ({
           'labName': 'Data Structures – 1',
           'discipline': 'Computer Science and Engineering',
           'college': 'IIITH',
           'phase': '3',
           'expName': 'Poly Arithmetic',
           'expShortName': 'poly-arithmetic'
           });


           (function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({'gtm.start':
           new Date().getTime(),event:'gtm.js'});var
           f=d.getElementsByTagName(s)[0],
           j=d.createElement(s),dl=l!='dataLayer'?'&l='+l:'';j.async=true;j.src=
           'https://www.googletagmanager.com/gtm.js?id='+i+dl;f.parentNode.insertBefore(j,f);
           })(window,document,'script','dataLayer','GTM-W59SWTR');
         </script>
        <!-- End Google Tag Manager -->

    </head>
    <body>
      <!-- Google Tag Manager (noscript) -->
      <noscript class="gtm">
          <iframe height="0" width="0"
            src="https://www.googletagmanager.com/ns.html?id=GTM-W59SWTR"
            style="display:none;visibility:hidden">
          </iframe>
      </noscript>
      <!-- End Google Tag Manager (noscript) -->
      
      <div class="exp" title="Polynomial Arithmetic">
            <div class="longt" >
                <h1 class="hlongt">Introduction to Polynomial Arithmetic using Linked list</h1>
            </div>
            <div class="preamble">
                <div class="art txt" title="Estimation">
                    <div class="longt">
                        <h2 class="hlongt">Estimated Time</h2>
                    </div>
                    <div class="art-body">
                        <p>1 hour</p>
                    </div>
                </div>

                <div class="art req" title="Experiment Introduction">
                    <div class="longt">
                        <h2 class="hlongt">A Short Introduction to Experiment</h2>
                    </div>
                    <div class="description">
                        <p>Introduction Video to Experiment</p>
                    </div>            
                </div>

                <div class="art txt" title="Prerequisites">
                    <div class="longt">
                        <h2 class="hlongt">Prerequisites of the Experiment</h2>
                    </div>
                    <div class="art-body">
                        <ul>
                            <li>Basic knowledge on <a href="exp-iiith.vlabs.ac.in/ll/exp.html">Linked List</a>
                            </li>
                            <li>And above all, a curiosity
                                to learn and explore..!
                            </li>
                        </ul>
                    </div>
                </div>

                <div class="art txt" title="Overview">
                    <div class="longt">
                        <h2 class="hlongt">Overview of the Experiment</h2>
                    </div>
                    <div class="art-body">
                        <p> The experiment features a series
                            of modules with video lectures, demos,
                            hands-on practice, exercises and
                            quizzes to self analyze.
                        </p>
                    </div>
                </div>
                
                <div class="art txt" title="Learning Objectives">
                    <div class="longt">
                        <h2 class="hlongt">Learning Objectives of the Experiment</h2>
                    </div>
                    <div class="art-body">
                        <p>In this experiment, you will be
                            able to do the following:</p>
                        <ul>
                            <li>Demonstrate understanding of
                                the concepts of Polynomial using Linked list
                            </li>

                            <li>Given a polynomial, one can learn practically on how to add, subtract and multiply using Linked list
                            </li>
                        </ul>
                    </div>
                </div>

                <div class="art txt" title="Modules and Weightage">
                    <div class="longt">
                        <h2 class="hlongt">Experiment Modules & their Weightage</h2>
                    </div>
                    <div class="art-body">
                        <table>
                            <thead>
                                <tr>
                                    <th style="text-align:center">Module</th>
                                    <th style="text-align:center">Weightage</th>
                                    <th style="text-align:center">Expectation</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>Pre-test</td>
                                    <td>20%</td>
                                    <td>Solve All Questions</td>
                                </tr>
                                <tr>
                                    <td>Polynomials</td>
                                    <td>20%</td>
                                    <td>Understand the concept Polynomials</td>
                                </tr>
                                <tr>
                                    <td>Polynomial Arithmetic (Linked list)</td>
                                    <td>40%</td>
                                    <td>Understand the Polynomial Arithmetic (Linked list)</td>
                                </tr>
                                <tr>
                                    <td>Post-test</td>
                                    <td>20%</td>
                                    <td>Solve all Questions</td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
            
            <div class="lu" title="Pre-Test">
                <div class="longt" >
                    <h1 class="hlongt">Pre-Test of the Experiment</h1>
                </div>
                
                <div class="preamble">
                    <div class="art txt" title="Estimation">
                        <div class="longt">
                            <h2 class="hlongt">Estimated Time</h2>
                        </div>
                        <div class="art-body">
                            <p>10 minutes</p>
                        </div>
                    </div>
                    
                    <div class="art txt" title="Pre-test Instructions">
                        <div class="longt">
                            <h2 class="hlongt">Instructions for Pre-test of the Experiment</h2>
                        </div>
                        <div class="art-body">
                            <ul>
                                <li>Pretest includes
                                    questions on <strong>Linked list and Polynomials </strong>
                                </li>
                                <li>If you want to revise
                                    these topics before
                                    taking the quiz, go
                                    through the Recap module
                                    first.
                                </li>
                                <li>Read the questions in
                                    the quiz section and
                                    select the correct
                                    option from the ones
                                    provided. Please note
                                    that some
                                    <strong>questions may
                                    have more than one
                                    correct response.
                                    </strong>
                                </li>
                            </ul>
                        </div>
                    </div>
                </div>

                <div class="task" title="Recap">
                    <div class="longt">
                        <h2 class="hlongt">Quick look at
                            Linked list and Polynomials
                        </h2>
                    </div>

                    <div class="art txt" title="Linked list">
                        <div class="longt">
                            <h2 class="hlongt">What is Linked list?</h2>
                        </div>
                        <div class="art-body">
                            <p>A Linked list consists of nodes where each node contains a data field and a reference(link) to the next node in the list.
                            </p>
                        </div>
                    </div>

                    <div class="art txt" title="Linked list Types">
                        <div class="longt">
                            <h2 class="hlongt">Types of Linked list</h2>
                        </div>
                        <div class="art-body">
                            <p>
                            <ul>
                                <li>Singly Linked list: It contain nodes which have a data part as well as an address part i.e. next, which points to the next node in the sequence of nodes.</li> <br>
                               <li>Doubly Linked list: In this, each node contains a data part and two addresses, one for the previous node and one for the next node.</li> <br>
                               <li>Circular Linked list: In this, the last node of the list holds the address of the first node hence forming a circular chain.</li> 
                            </ul>
                            </p>
                        </div>
                    </div>

                    <div class="art req" title="Pictorial representation">
                        <div class="longt">
                            <h2 class="hlongt">Pictorial representation of Linked list</h2>
                        </div>
                        <div class="description">
                            <p>Image of singly, doubly and circular linked list</p>
                        </div>            
                    </div>
                </div>
                               
                <div class="quiz" title="Pre-Test Quiz">
                    <div class="longt">
                        <h2 class="hlongt">A Quiz with Multiple Choice Questions</h2>
                    </div>

                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question1">
                                <div class="art-body">
                                    <p>Q1. Which of the following points is/are true about Linked List data structure when it is compared with array?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) Arrays have better cache locality that can make them better in terms of performance.</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) It is easy to insert and delete elements in Linked List</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(C) Random access is not allowed in a typical implementation of Linked Lists</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(D) All of the above</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Explanation of question 1 for the
                                        right answer.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question2">
                                <div class="art-body">
                                    <p>Q2. The time required to search an element in a linked list of length n is ____.</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) O (log n)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) O (n)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) O (1)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(D) O(n^2)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>In the worst case, the element to be searched has to be compared with all elements of linked list. It will take O(n) time to search the element. So, option (B) is correct.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question3">
                                <div class="art-body">
                                    <p>Q3. Assume that reference of head of following doubly linked list is passed to above function 1 <--> 2 <--> 3 <--> 4 <--> 5 <-->6. What should be the modified linked list after the function call?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) 2 <--> 1 <--> 4 <--> 3 <--> 6 <-->5</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) 5 <--> 4 <--> 3 <--> 2 <--> 1 <-->6</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) 6 <--> 5 <--> 4 <--> 3 <--> 2 <--> 1</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(D) 6 <--> 5 <--> 4 <--> 3 <--> 1 <--> 2</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>The given function reverses the given doubly linked list
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question4">
                                <div class="art-body">
                                    <p>Q4. Which of the following sorting algorithms can be used to sort a random linked list with minimum time complexity?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) Insertion Sort</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) Quick Sort</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) Heap Sort</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(D) Merge Sort</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Both Arrays and Linked List can be used to store linear data of similar types, but they both have some advantages and disadvantages over each other.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question5">
                                <div class="art-body">
                                    <p>Q5. The concatenation of two lists is to be performed in O(1) time. Which of the following implementations of a list should be used?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) singly linked list</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) doubly linked list</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) circular doubly linked list</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(D) array implementation of lists</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Singly linked list cannot be answer because we cannot find last element of a singly linked list in O(1) time. Doubly linked list cannot also not be answer because of the same reason as singly linked list.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                </div>
            </div>
            
            <div class="lu" title="Polynomials">
                <div class="longt">
                    <h1 class="hlongt">Basics of Polynomials</h1>
                </div>

                <div class="preamble">
                    <div class="art txt" title="Estimation">
                        <div class="longt">
                            <h2 class="hlongt">Estimated Time</h2>
                        </div>
                        <div class="art-body">
                            <p>1 hour</p>
                        </div>
                    </div>
                
                    <div class="art txt" title="Learning Objectives">
                        <div class="longt">
                            <h2 class="hlongt">Learning Objectives of the Experiment</h2>
                        </div>
                        <div class="art-body">
                            <p>In this experiment, you will be
                                able to do the following:</p>
                            <ul>
                                <li>Demonstrate understanding of
                                    the concepts of Polynomial using Linked list
                                </li>
                                <li>Given a polynomial, one can learn practically on how to add, subtract and multiply using Linked list
                                </li>
                            </ul>
                        </div>
                    </div>

                    <div class="art req" title="Basic Concept">
                        <div class="longt">
                            <h2 class="hlongt">Introduction of Polynomials</h2>
                        </div>
                        <div class="description">
                            <p>Introduction Video to Polynomials</p>
                        </div>            
                    </div>
                </div>

                <div class="task" title="Algorithm">
                    <div class="longt">
                        <h2 class="hlongt">Polynomial Arithmetic using Linked List Algorithm</h2>
                    </div>
                    <div class="art txt" title="Algorithm of Polynomial representation">
                        <div class="longt">
                            <h2 class="hlongt">Algorithm behind Polynomial representation using Linked list</h2>
                        </div>
                        <div class="art-body">
                            <p>
                            <ol>
                                <li>Loop around all values of linked list and follow step 2& 3.</li>
                                <li>If the value of a node’s exponent. is greater copy this node to result node and head towards the next node.</li>
                                <li>If the values of both node’s exponent is same add the coefficients and then copy the added value with node to the result.</li>
                                <li>Print the resultant node.</li>
                            </ol>
                            </p>
                        </div>
                    </div>

                    <div class="art req" title="Polynomial using Linked list Algorithm">
                        <div class="longt">
                            <h2 class="hlongt">Algorithm behind Polynomial using Linked list</h2>
                        </div>
                        <div class="description">
                            <p>Video/ Image of polynomial algorithm explanation</p>
                        </div>
                    </div>
                </div>

                <div class="task" title="Representation">
                    <div class="longt">
                        <h2 class="hlongt">Representation of Polynomials using Linked List</h2>
                    </div>
                    <div class="art txt" title="Theory of Polynomial representation">
                        <div class="longt">
                            <h2 class="hlongt">Polynomial representation using Linked list</h2>
                        </div>
                        <div class="art-body">
                            <p>
                            <ul>
                                A polynomial can be thought of as an ordered list of non zero terms. Each non zero term is a two-tuple which holds two pieces of information:
                                <br>
                                <br>
                                <li>The exponent part</li>
                                <li>The coefficient part</li>
                            </ul>
                            </p>
                        </div>
                    </div>

                    <div class="art req" title="Representation of Polynomials">
                        <div class="longt">
                            <h2 class="hlongt">Pictorial Representation</h2>
                        </div>
                        <div class="description">
                            <p>Video/ Image of polynomial explanation</p>
                        </div>
                    </div>
                </div>
            </div>

            <div class="lu" title="Polynomial Arithmetic (Linked list)">
                <div class="longt">
                    <h1 class="hlongt">Polynomial Arithmetic (Linked list)</h1>
                </div>

                <div class="preamble">
                    <div class="art txt" title="Estimation">
                        <div class="longt">
                            <h2 class="hlongt">Estimated Time</h2>
                        </div>
                        <div class="art-body">
                            <p>1 hour</p>
                        </div>
                    </div>

                    <div class="art txt" title="Learning Objectives">
                        <div class="longt">
                            <h2 class="hlongt">Learning Objectives of the Experiment</h2>
                        </div>
                        <div class="art-body">
                            <p>In this experiment, you will be
                                able to do the following:</p>
                            <ul>
                                <li>Demonstrate understanding of
                                    the concepts of Polynomial using Linked list
                                </li>

                                <li>Given a polynomial, one can learn practically on how to add, subtract and multiply using Linked list
                                </li>
                            </ul>
                        </div>
                    </div>

                    <!--div class="art req" title="Polynomial Arithmetic:Linked list">
                        <div class="longt">
                            <h2 class="hlongt">Introduction of Polynomial Arithmetic(Linked List)</h2>
                        </div>
                        <div class="description">
                            <p>Introduction Video to Polynomials</p>
                        </div>            
                    </div-->
                </div>

                <div class="task" title="Addition of Polynomials">
                    <div class="longt">
                        <h2 class="hlongt">Addition of Polynomials using Linked list</h2>
                    </div>
                    <div class="art txt" title="Theory of Addition of Polynomials using ll">
                        <div class="longt">
                            <h2 class="hlongt">Addition of Polynomials using Linked list Theory</h2>
                        </div>
                        <div class="art-body">
                            <p>
                            <ul>
                                <li>In the polynomial linked list, the coefficients and exponents of the polynomial are defined as the data node of the list.
                                </li>
                            <br>
                                <li>For adding two polynomials that are stored as a linked list. We need to add the coefficients of variables with the same power. In a linked list node contains 3 members, coefficient value link to the next node.
                                </li>
                            </ul>
                            </p>
                        </div>
                    </div>
                    <div class="art req" title="Polynomial Addition">
                        <div class="longt">
                            <h2 class="hlongt">Polynomial Addition using Linked list</h2>
                        </div>
                        <div class="description">
                            <p>Video/ Image of polynomial explanation</p>
                        </div>
                    </div>
                </div>

                <div class="task" title="Subtraction of Polynomials">
                    <div class="longt">
                        <h2 class="hlongt">Subtraction of Polynomials using Linked list</h2>
                    </div>
                    <div class="art txt" title="Theory of Subtraction of Polynomials using ll">
                        <div class="longt">
                            <h2 class="hlongt">Subtraction of Polynomials using Linked list Theory</h2>
                        </div>
                        <div class="art-body">
                            <p>
                            <ul>
                                <li>In the polynomial linked list, the coefficients and exponents of the polynomial are defined as the data node of the list.
                                </li>
                                <br>
                                <li>For subtracting two polynomials that are stored as a linked list. We need to subtract the coefficients of variables with the same power. In a linked list node contains 3 members, coefficient value link to the next node.
                                </li>
                            </ul>
                            </p>
                        </div>
                    </div>
                    <div class="art req" title="Polynomial Subtraction">
                        <div class="longt">
                            <h2 class="hlongt">Polynomial Subtraction using Linked list</h2>
                        </div>
                        <div class="description">
                            <p>Video/ Image of polynomial explanation</p>
                        </div>
                    </div>
                </div>

                <div class="task" title="Multiplication of Polynomials">
                    <div class="longt">
                        <h2 class="hlongt">Multiplication of Polynomials using Linked list</h2>
                    </div>
                    <div class="art txt" title="Theory of Multiplication of Polynomials (Linked list)">
                        <div class="longt">
                            <h2 class="hlongt">Multiplication of Polynomials using Linked list Theory</h2>
                        </div>
                        <div class="art-body">
                            <p>
                            <ul>
                                <li>In this approach we will multiply the 1st polynomial with each term of 2nd polynomial.</li>
                                <li>Store the multiplied value in a new linked list.</li>
                                <li>Then we will add the coefficients of elements having the same power in resultant polynomial.</li>
                            </ul>
                            </p>
                        </div>
                    </div>
                    <div class="art req" title="Polynomial Multiplication">
                        <div class="longt">
                            <h2 class="hlongt">Polynomial Multiplication using Linked list</h2>
                        </div>
                        <div class="description">
                            <p>Video/ Image of polynomial explanation</p>
                        </div>
                    </div>
                </div>

                <div class="task" title="Demo">
                    <div class="longt">
                        <h2 class="hlongt">Demo of Polynomials using Linked list</h2>
                    </div>
                    <div class="art req" title="Demonstration of Polynomials:Linked list">
                        <div class="longt">
                            <h2 class="hlongt">Demonstration of Polynomials using Linked list</h2>
                        </div>
                        <div class="description">
                            <p>Demo of polynoimals addition, subtraction and multiplication artefact</p>
                        </div>
                    </div>
                </div> 

                <div class="task" title="Practice">
                    <div class="longt">
                        <h2 class="hlongt">Practice of Polynomials using Linked list</h2>
                    </div>
                    <div class="art req" title="Practice of Polynomials:Linked list">
                        <div class="longt">
                            <h2 class="hlongt">Practice of Polynomials using Linked list</h2>
                        </div>
                        <div class="description">
                            <p>Practice of polynoimals addition, subtraction and multiplication artefact</p>
                        </div>
                    </div>
                </div> 

                <div class="task" title="Exercise">
                    <div class="longt">
                        <h2 class="hlongt">Exercise of Polynomials using Linked list</h2>
                    </div>
                    <div class="art req" title="Exercise of Polynomials:Linked list">
                        <div class="longt">
                            <h2 class="hlongt">Exercise of Polynomials using Linked list</h2>
                        </div>
                        <div class="description">
                            <p>Exercise of polynoimals addition, subtraction and multiplication artefact</p>
                        </div>
                    </div>
                </div> 

                <div class="quiz" title="Polynomials Quiz">
                    <div class="longt">
                        <h2 class="hlongt">A Quiz with Multiple Choice Questions</h2>
                    </div>
                    
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question1">
                                <div class="art-body">
                                    <p>Q1. How is a Polynomial addition is performed?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) Based on power</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) Based on Coefficient</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(C) Based on both power and coefficient</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(C) None of the above</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Polynomial addition is performed based on power. If powers are equal then the coefficients are added.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question2">
                                <div class="art-body">
                                    <p>Q2. Time complexity of Polynomial arithmetic using Linked list is ____</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) log(n)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) O(nlogn)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) O(m + n)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) log(O(m + n))</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>O(m + n) where m and n are number of nodes in first and second lists respectively.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
<!--   -->
            <div class="lu" title="Analysis">
                <div class="longt">
                    <h1 class="hlongt">Analysis of Polynomials using Linked list</h1>
                </div>

                <div class="preamble">
                    <div class="art txt" title="Estimation">
                        <div class="longt">
                            <h2 class="hlongt">Estimated Time</h2>
                        </div>
                        <div class="art-body">
                            <p>1 hour</p>
                        </div>
                    </div>
                
                    <div class="art txt" title="Learning Objectives">
                        <div class="longt">
                            <h2 class="hlongt">Learning Objectives of the Experiment</h2>
                        </div>
                        <div class="art-body">
                            <p> In this module, we will be learning about :
                            <ul>
                                <li>Time and Space Complexity : We will learn about the running time of one iteration to complete the polynomial using linkedlist process.
                                </li>
                                <li>We will learn about stability of  polynomials uisng linked list algorithms. Then we will see how polynomials works.</li>
                                <li>Comparison with other algorithms : We will compare polynomials using linked list with other algorithms and see in which situations polynomials is the optimal/not optimal approach to take.</li>
                            </ul>
                            </p>
                        </div>
                    </div>
                </div>

                <div class="task" title="Time and Space Complexity">
                    <div class="longt">
                        <h2 class="hlongt">Time and Space Complexity of Polynomial using Linked list</h2>
                    </div>
                    <div class="art txt" title="Time and Space Complexity in Polynomial">
                        <div class="longt">
                            <h2 class="hlongt">Time and Space Complexity of Polynomial Arithmetic using Linked list</h2>
                        </div>
                        <div class="art-body">
                            <p>
                            <ul>
                                <li>For most of the algorithms associated with this course, time complexity comparisons are more interesting than space complexity comparisons
                                <li>In general though, analysis yield upper bounds rather than exact formulae.</li>
                                <li>Time complexity expresses the relation between the size of the input and runtime for the algorithm</li>
                                <li>Analysis of polynomials using Linked list can be based on:
                                    <ol>
                                        <li>Number of arithmetic operations performed</li>
                                        <li>Number of comparisons made</li>
                                        <li>Number of array elements accessed</li>
                                    </ol>                               
                            </ul>
                            </p>
                        </div>
                    </div>
                    <div class="art txt" title="Best and Worst case of Polynomial Arithmetic using Linked list">
                        <div class="longt">
                            <h2 class="hlongt">Best and Worst case of Polynomial using Linked list</h2>
                        </div>
                        <div class="art-body">
                            <p>
                            <ul>
                                <li>Worst case analysis is used to find an upper bound on algorithm performance for large problems (large n)</li>
                                <li>Best case analysis determines the average (or expected) performance
                                Worst case time complexity is usually simpler to work out</li>
                            </ul>
                            </p>
                        </div>
                    </div>
                    <div class="art req" title="Comparison with other Algorithms">
                        <div class="longt">
                            <h2 class="hlongt">Comparison of Polynomial with other Algorithms</h2>
                        </div>
                        <div class="description">
                            <p>Image of time complexity</p>
                        </div>            
                    </div>
                </div>
            </div>

            <div class="lu" title="Post Test">
                <div class="longt">
                    <h2 class="hlongt">Post Test of the Experiment</h2>
                </div>
                <div class="preamble">
                    <div class="art txt" title="Estimation">
                        <div class="longt">
                            <h2 class="hlongt">Estimated Time</h2>
                        </div>
                        <div class="art-body">
                            <p>10 minutes</p>
                        </div>
                    </div>
                    <div class="art txt" title="Instructions">
                        <div class="longt">
                            <h2 class="hlongt">Instructions for Quiz</h2>
                        </div>
                        <div class="art-body">
                            <p>Post Test includes questions
                               on entire experiment
                               concepts. Read the questions
                               in the quiz section and
                               select the correct option
                               from the ones
                               provided. Please note that
                               some questions may have more
                               than one correct response.
                            </p>
                        </div>
                    </div>
                </div>
                <div class="quiz" title="Post-test Quiz">
                    <div class="longt">
                        <h2 class="hlongt">Post test quiz</h2>
                    </div>                    
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question1">
                                <div class="art-body">
                                    <p>Q1. Under regular addition of polynomials, the sum would contain a term 2x^6. This term becomes ____ and is dropped when the answer is reduced modulo 2.
                                    </p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) 3x^6</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) 0x^6</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) Doesn't change</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p> 
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question2">
                                <div class="art-body">
                                    <p>Q2. Each term of the polynomial will be pointing to the other term and the last term will be pointing to ____.</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) Last coefficient</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) First coefficient</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) Null</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c4">
                                    <div class="art-body">
                                        <p>(D) The number itself</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Every term in the polynomial will be pointing to the other term and the last term will always point to null 
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question3">
                                <div class="art-body">
                                    <p>Q3. What are the advantages of using a linked list rather than array?
                                    </p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) List elements can be easily inserted or removed</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) It is easy compared to array</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) Both A and B</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(D) None of the above</p> 
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>The principal benefit of a linked list over a conventional array is that the list elements can be easily inserted or removed without reallocation or reorganization of the entire structure because the data items need not be stored contiguously in memory or on disk, while restructuring an array at run-time is a much more
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mcq">  
                        <div class="preamble">
                            <div class="art txt" title="question4">
                                <div class="art-body">
                                    <p>Q4. Select any one of the advantage of using Arrays for performing polynomial arithmetic operations?
                                    </p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) It is straight forward process</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) Comparing the exponents is easy process</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) Array representation assumes that the exponents of the given expression are arranged from 0 to the infinity</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c4">
                                    <div class="art-body">
                                        <p>(D) None of the above</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>For adding two polynomials using arrays is straightforward method, since both the arrays may be added up element wise beginning from 0 to n-1, resulting in addition of two polynomials
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>                    
                </div>
            </div>

            <div class="lu" title="Further Readings/References">
                <div class="longt">
                    <h2 class="hlongt">Further Readings and References of the Experiment</h2>
                </div>
                <div class="preamble">
                    <div class="art txt" title="Explore">
                        <div class="longt">
                            <h2 class="hlongt">Explore More About Polynomial Arithmetic (Linked list)</h2>
                        </div>
                        <div class="art-body">
                            <p>You can explore more about
                               Polynomial Arithmetic (Linked list) Experiment
                               through following resources:
                            </p>
                            <br>
                            <b>Useful Links :</b>
                            <ul>
                                <li><a href="https://en.wikipedia.org/wiki/Polynomial">Polynomials</a></li>
                                <li><a href="https://en.wikipedia.org/wiki/Linked_list">Linked list</a></li>
                            </ul>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <script src="js/loader.js"></script>
    </body>
</html>
